#include <SoftwareSerial.h>

#define echoPinB 8
#define trigPinB 9 
#define echoPinF 10 
#define trigPinF 11 

long duration; 
int distance = 0; 
char Incoming_value = 0;
char automat = 0;
SoftwareSerial BTSerial(0, 1);

void setup() {
  pinMode(2, OUTPUT);
  pinMode(3, OUTPUT);
  pinMode(4, OUTPUT);
  pinMode(5, OUTPUT);
  pinMode(6, OUTPUT); 
  pinMode(7, OUTPUT);
  BTSerial.begin(9600);
  Serial.begin(9600);
  Serial.println("first");

  pinMode(trigPinF, OUTPUT); 
  pinMode(echoPinF, INPUT); 
  pinMode(trigPinB, OUTPUT); 
  pinMode(echoPinB, INPUT);
}

void mers_inapoi() {
    digitalWrite(7, HIGH);
    digitalWrite(5, LOW);
    analogWrite(6, 120);

    digitalWrite(4, HIGH);
    digitalWrite(2, LOW);
    analogWrite(3, 120);
  
    delay(200);
}

void mers_inainte() {
    digitalWrite(5, HIGH);
    digitalWrite(7, LOW);
    analogWrite(6, 120);

    digitalWrite(2, HIGH);
    digitalWrite(4, LOW);
    analogWrite(3, 120);
  
    delay(400);
}

void rotire_drepata() {
    digitalWrite(7, HIGH);
    digitalWrite(5, LOW);
    analogWrite(6, 140);

    digitalWrite(2, HIGH);
    digitalWrite(4, LOW);
    analogWrite(3, 140);
  
    delay(350);
}

void rotire_stanga() {
    digitalWrite(5, HIGH);
    digitalWrite(7, LOW);
    analogWrite(6, 140);

    digitalWrite(4, HIGH);
    digitalWrite(2, LOW);
    analogWrite(3, 140);
  
    delay(350);
}

void resetare_roti() {
    digitalWrite(7, LOW);
    digitalWrite(5, LOW);
    digitalWrite(4, LOW);
    digitalWrite(2, LOW);
}

void senzor(int trig, int echo) {
 
  digitalWrite(trig, LOW);
  delayMicroseconds(2);
  digitalWrite(trig, HIGH);
  delayMicroseconds(10);
  digitalWrite(trig, LOW);
  duration = pulseIn(echo, HIGH);
  distance = duration * 0.034 / 2; 
}

#define senzor_fata() senzor(trigPinF, echoPinF)
#define senzor_spate() senzor(trigPinB, echoPinB)

void move_alone() {
    senzor_fata();
    if (distance >= 50) {
      mers_inainte();
      resetare_roti();
    } else {
        for (int i = 0; i < 6; i++) {
          rotire_stanga();
          resetare_roti();
          senzor_fata();
          if (distance >= 50) {
            mers_inainte();
            resetare_roti();
            return;
          }
        }

        mers_inapoi();
        resetare_roti();
    }
}

void loop() {
  if(BTSerial.available() > 0) {
    Incoming_value = BTSerial.read();      
    if(Incoming_value == '1') {            
      senzor_fata();
      if (distance >= 50)    
        mers_inainte();
    } else if(Incoming_value == '2') {     
      senzor_spate();
      if (distance >= 25)
        mers_inapoi();
    } else if(Incoming_value == '3') {   
      rotire_stanga();
    } else if (Incoming_value == '4') {
      rotire_drepata();
    } else if (Incoming_value == '5') {
      automat = !automat;
    }

      resetare_roti();
    }

    if (automat) {
      move_alone();
    }
}
